=== debian/changelog ===
hm (18.0-2) unstable; urgency=medium

  * d/watch: Update for changed GitLab tags page.
  * d/control: Mark "all" packages as "Multi-Arch: foreign".
  * Add patch to fix building on Hurd.
  * d/control: Update "Standards-Version" to 4.7.0

 -- Joachim Bauch <bauch@struktur.de>  Wed, 15 May 2024 20:53:57 +0200

hm (18.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1060678)

 -- Joachim Bauch <bauch@struktur.de>  Fri, 12 Jan 2024 22:55:23 +0100
