=== debian/control ===
Source: hm
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Joachim Bauch <bauch@struktur.de>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 lsb-release
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://vcgit.hhi.fraunhofer.de/jvet/HM
Vcs-Browser: https://salsa.debian.org/multimedia-team/hm
Vcs-Git: https://salsa.debian.org/multimedia-team/hm.git

Package: hm
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 hm-config
Suggests:
 hm-doc
Description: Reference software for HEVC - standard bitdepth
 This software package is the reference software for Rec. ITU-T H.265 |
 ISO/IEC 23008-2 High Efficiency Video Coding (HEVC).
 .
 The reference software includes both encoder and decoder functionality.
 .
 This package contains the applications with standard bitdepth support.

Package: hm-highbitdepth
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 hm-config
Suggests:
 hm-doc
Description: Reference software for HEVC - high bitdepth
 This software package is the reference software for Rec. ITU-T H.265 |
 ISO/IEC 23008-2 High Efficiency Video Coding (HEVC).
 .
 The reference software includes both encoder and decoder functionality.
 .
 This package contains the applications with high bitdepth support.

Package: hm-config
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Suggests:
 hm-doc
Description: Reference software for HEVC - config files
 This software package is the reference software for Rec. ITU-T H.265 |
 ISO/IEC 23008-2 High Efficiency Video Coding (HEVC).
 .
 The reference software includes both encoder and decoder functionality.
 .
 This package contains config files for the encoder.

Package: hm-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Description: Reference software for HEVC - documentation
 This software package is the reference software for Rec. ITU-T H.265 |
 ISO/IEC 23008-2 High Efficiency Video Coding (HEVC).
 .
 The reference software includes both encoder and decoder functionality.
 .
 This package contains the documentation.
