=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s/.*\/HM-HM-([\d\.]+)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/g \
 https://vcgit.hhi.fraunhofer.de/api/v4/projects/jvet%2FHM/releases /jvet/HM/-/archive/HM-[\d\.]+/HM-HM-([\d\.]+)\.tar\.gz
